/*
tsthash.c Version 0.1.0  Hash test hash algorithm
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

#define MAXLMT  9999999

void putstx(char *pgm)
   {
   fprintf(stderr,"Usage: %s filename "
      "number\n", pgm);
   fprintf(stderr,"Where number is "
      "1 to %d\n", MAXLMT);
   exit(1);
   } /* putstx */

int main(int argc, char **argv)
   {
   int i;
   int lmt;
   int opnerr;
   long ofst;
   hashfmt *hshhdr;
   unsigned char *p,*q;
   unsigned char key[256];
   unsigned char dbname[256];
   if (argc != 3) putstx(*argv);
   strcpy(dbname,*(argv+1));
   lmt = atoi(*(argv+2));
   if (lmt < 1 || lmt > MAXLMT)
      {
      fprintf(stderr,"tsthash: invalid number\n");
      putstx(*argv);
      } /* if invalid lmt */

   hshhdr = (hashfmt *) hopen(dbname,READ,NOLOCK,&opnerr);
   if (hshhdr == NULL)
      {
      fprintf(stderr,"tsthash: error %d "
	 "opening %s\n",
	 opnerr, dbname);
      exit(1);
      } /* open err */

   p = (unsigned char *) key;
   q = (unsigned char *) p + hshhdr->keylen;
   while (p < q) *p++ = 'A';
   *p = '\0';
   i = lmt;
   while (i--)
      {
      ofst = hash(hshhdr,key);
      printf("%5d.  %08x  %s\n",
         lmt - i, ofst, key);
      p = (unsigned char *) key + hshhdr->keylen - 1;
      q = (unsigned char *) key;
      while (p >= q)
         {
         (*p)++;
         if (*p <= 'Z') break;
         *p = 'A';
         p--;
         } /* right to left */
      } /* for each key to hash */
   return(0);
   } /* main */
